library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity get_sADC12_50 is
port (clk : in std_logic; 
 	abeg : in std_logic; 
 	abusy : out std_logic; 
 	adata : out std_logic_vector(11 downto 0); 
	ADC_cs				: out  std_logic;
	ADC_clk				: out  std_logic;
	ADC_din				: in  std_logic
 		); 
end get_sADC12_50;

architecture Behavioral of get_sADC12_50 is
	signal dbeg, ddbeg, dton, cswait, pack, dack : STD_LOGIC;
	signal dbuf : STD_LOGIC_VECTOR(15 downto 0);
	signal wordct : STD_LOGIC_VECTOR(3 downto 0);
	signal ckct : STD_LOGIC_VECTOR(1 downto 0);
begin
abusy <= dton;
ADC_clk <= pack or dack;

process (clk) 
begin
if clk='1' and clk'event then
	dbeg<=abeg;	ddbeg<=dbeg;
	if dton='0' and dbeg='1' and ddbeg='0' then	--check header
		dton <= '1';
		cswait <= '1';
		ADC_cs <= '0';	--ADC IC on
		pack <= '0';	--a delay more than 10ns is needed.	2011 12/8
		wordct <= (others=>'0');
		ckct <= (others=>'0');
	elsif cswait='1' then
		cswait <= '0';
	elsif dton='1' then
		if wordct="1111" then	--end at 15 loop
			dton <= '0';
--			adata <= dbuf(12 downto 1);	--ADC data
			adata <= dbuf(11 downto 0);	--ADC data
		else
			if ckct>="10" then
				ckct <= (others=>'0');
				wordct <= wordct+1;
			else
				ckct <= ckct+1;
			end if;
			if ckct="00" then	--30ns cycle of sck at 50MHz
				dbuf(15 downto 0) <= dbuf(14 downto 0)&ADC_din;
				pack <= '1';
			elsif ckct="01" then	--60ns pulse width of sck at 50MHz
				pack <= '0';
			end if;
		end if;
	else
		pack <= '1';
		ADC_cs <= '1';	--ADC IC off
	end if;
end if;
if clk='0' and clk'event then
	dack <= pack;
end if;
end process;

end Behavioral;
