library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;

entity kp_gen50MHz is
    Port ( clk : in std_logic;
	caddr : in std_logic_vector(7 downto 0);		--crate address
	t0tm : in std_logic_vector(39 downto 0);		--max time bin
	ptclock : in std_logic_vector(55 downto 0);		--real clock
	nkp : in std_logic;
	rkp : out std_logic);
end kp_gen50MHz;

architecture Behavioral of kp_gen50MHz is
	signal fnkp, snkp, prkp, kplow, kphi : STD_LOGIC;
	signal kpct, sendtmct, tmct : STD_LOGIC_VECTOR(7 downto 0);
	signal ptmdt: STD_LOGIC_VECTOR(103 downto 0);

	signal bitch : STD_LOGIC_VECTOR(7 downto 0);

	constant m1us: STD_LOGIC_VECTOR(7 downto 0) := X"31";--49 @50MHz, X"27";	--1us =39 @40MHz
	constant m2us: STD_LOGIC_VECTOR(7 downto 0) := X"63";--99 @50MHz X"4f";	--2us =79 @40MHz
	constant m5us: STD_LOGIC_VECTOR(7 downto 0) := X"f9";--249 @50MHz X"c7";	--5us =199 @40MHz
	constant stmnum: STD_LOGIC_VECTOR(7 downto 0) := X"68";	--104 bits = 104

begin
rkp <= prkp;

process (CLK) 
begin
if CLK='1' and CLK'event then
	fnkp <= nkp;
	snkp <= fnkp;
	if fnkp='1' then	--checking if kp is low.
		kpct <= (others=>'0');
	elsif fnkp='0' and snkp='0' then	--checking if kp is low.
		if kpct/=X"ff" then
			kpct <= kpct+1;
		end if;
	end if;
	if kplow='1' then	--kp low.
		if tmct/=X"00" then
			tmct <= tmct-1;
		else
			kplow <= '0';
			if sendtmct/=X"00" then
				sendtmct <= sendtmct-1;
				kphi <= '1';
				prkp <= '1';
				ptmdt <= ptmdt(102 downto 0)&"0";
				if ptmdt(103)='1' then
					tmct <= m2us;
				else
					tmct <= m1us;
				end if;
			end if;
		end if;
	elsif kphi='1' then	--kp hi.
		if tmct/=X"00" then
			tmct <= tmct-1;
		else
			prkp <= '0';
			kplow <= '1';
			kphi <= '0';
			tmct <= m1us;
		end if;
	elsif fnkp='1' and snkp='0' and kpct=X"ff" then	--t0 signal is rising up.
		ptmdt(103 downto 96) <= caddr;
		ptmdt(95 downto 56) <= t0tm;
		ptmdt(55 downto 0) <= ptclock;
		tmct <= m5us;
		kphi <= '1';
		prkp <= '1';
		sendtmct <= stmnum;
	end if;
end if;

end process;

end Behavioral;
